# Contributing to Remix PWA

Thank you for your interest in contributing 😊😝!

We love your input! We want to make contributing to this project as easy and transparent as possible, whether it's:

- Reporting a bug
- Discussing the current state of the code and proposing changes
- Submitting a fix
- Proposing new features

## 💻 Setup

Before you can contribute to `remix-pwa` codebase, you will need to fork the repo. 

1. **Fork the repo**: To fork the repo, simply click the <kbd>Fork</kbd> button on the top right of `remix-pwa` page. 

2. **Clone your fork locally**: After that, clone your forked repo using the command:
```sh
# in a terminal, cd to parent directory where you want your clone to be, then
git clone https://github.com/<your_github_username>/remix-pwa.git

cd remix-pwa
```

3. **Install dependencies**: `remix-pwa` uses npm. To download the dependencies, simply run:
```sh
npm install
```

Pull Requests should be made to different branches based on their context.

## 🐛 Found a Bug? 

If you think you found a bug that you can fix, clone the repo, make your changes and then submit a PR to the latest version branch (*Not every version of `remix-pwa` has a branch, this is done on purpose. Instead, submit your PR to the latest release. Every release has it's own branch*)

## 🛠 Suggesting a New Feature or Improving one?

If you feel you have a great idea for `remix-pwa` or you can improve an existing one, don't hesitate to work on it! No matter how small, we love it! Fork the repo and then, when you want to merge, create a PR to the `dev` branch. We would review it and if it passes all tests and scrutiny would be merged directly to `main`.

## 📬 Neglected Issue?

If you happen to come across an issue that you think is important but neglected, you can fork the repo and after you're done, if it involves changes to `remix-pwa` itself including template workers and the CLI, create a PR to the `dev` branch. If it involves tests, then create a PR to the `test` brnch.

## 😄 First PR?

Looking to make your first PR to Open Source? Then you can do so by simply correcting stuffs like typo in the README or even here in the contribution guide, it could also be explaining a particular topic or section more (in the README or here). Any PR of this type should be submitted to the `main` branch directly.

## 📃 License

By contributing, you agree that your contributions will be licensed under its MIT License.
